﻿// Autor: Targo Tennisberg
// Algoritmi kirjeldus:
// 1. Leiame iga kasti jaoks, mis on tema vasakpoolseim nähtav punkt ning parempoolseim nähtav punkt 
// 2. atan2 funktsioon võimaldab hõlpsasti leida, millise nurga alt vastavad punktid paistavad.
// 3. Iga punkt kas suurendab või vähendab horisonti parajasti varjavate takistuste arvu ühe võrra
// 4. Sorteerime punktid nurkade järgi 
// 5. Käime kõik punktid päripäeva läbi, loendades, mitu takistust parajasti on. 
// 6. Kui takistuste arv on 0, liidame vastava lõigu vastusele.
using System;
using System.Globalization;
using System.IO;

namespace jukuruudud
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length > 0 && args[0] == "all")
            for (int i = 0; i <= 31; i++)
            {
                Solve($"input{i}.txt", $"output{i}.txt");
            }
            else
            {
                Solve("horsis.txt", "horval.txt");
            }
        }

        static void Solve(string input, string output)
        {
            string[] lines = File.ReadAllLines(input);
            int n = int.Parse(lines[0]);
            Tuple<double, int>[] rays = new Tuple<double, int>[2 * n];

            for (int i = 0; i < n; i++)
            {
                string[] coords = lines[i + 1].Split(); 
                int x = int.Parse(coords[0]);
                int y = int.Parse(coords[1]);

                int lx = y >= 0 ? x : x + 1;  // leftmost point
                int ly = x >= 0 ? y + 1 : y;
                int rx = y >= 0 ? x + 1 : x;  // rightmost point
                int ry = x >= 0 ? y : y + 1;

                double la = Math.Atan2(lx, ly) / 2 / Math.PI; // left angle
                if (la < 0) la += 1;
                double ra = Math.Atan2(rx, ry) / 2 / Math.PI; // right angle
                if (ra <= 0) ra += 1;

                rays[2*i] = new Tuple<double, int>(la, 1);
                rays[2*i + 1] = new Tuple<double, int>(ra, -1);
            }

            Array.Sort(rays);

            int count = 0;
            double answer = 0;
            double prev = 0;
            foreach (Tuple<double, int> ray in rays)
            {
                if (count == 0)
                {
                    answer += ray.Item1 - prev;
                }
                prev = ray.Item1;
                count += ray.Item2;
            }
            answer += 1 - prev;

            File.WriteAllText(output, answer.ToString(CultureInfo.InvariantCulture) + Environment.NewLine);
        }
    }
}
