#include<iostream>
#include<fstream>
#include<vector>
#include<sstream>
#include<algorithm>
#include<cmath>
#include<limits>
#include<iomanip>
using namespace std;

struct Vec {
    int x, y;
};

int n, m;
int travellers[50][50];
vector<Vec> pts;

void quit(double score, string message) {
    cerr << message << "\n";
    cout << score << "\n";
    exit(0);
}


double get_average_time(istream &in) {
    int edges = 0;
    double time[50][50];
    fill(time[0], time[0]+50*50, numeric_limits<double>::infinity());
    {
        string s;
        for(int line_index=0; line_index < m && getline(in, s); line_index++) {
            istringstream iss(s);
            
            vector<int> line;
            int cur;
            while(iss >> cur) {
                cur--;
                if(cur < 0 || cur >= n)
                    quit(0, "Invalid network");
                line.push_back(cur);
            }
            if(line.size() > 1) {
                edges += line.size() - 1;
                for(int i=0;i<(int)line.size();i++) {
                    double curtime = -2;
                    for(int j=i+1;j<(int)line.size();j++) {
                        int li = line[i], lj = line[j];
                        curtime += 2 + hypot(pts[line[j]].x-pts[line[j-1]].x,
                                             pts[line[j]].y-pts[line[j-1]].y) / 1000.0;
                        time[li][lj] = min(time[li][lj], curtime);
                        time[lj][li] = time[li][lj];
                    }
                }
            }
        }
    }
    if(edges != n-1)
        quit(0, "Invalid network");
    //Finally do the all-pairs calculation
    for(int k=0;k<n;k++) {
        for(int i=0;i<n;i++) {
            for(int j=0;j<n;j++) {
                time[i][j] = min(time[i][j], time[i][k] + 5 + time[k][j]);
            }
        }
    }
    
    double average_time = 0.0, total_people = 0.0;
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            if(i != j) {
                if(std::isinf(time[i][j]))
                    quit(0, "Invalid network");
                average_time += time[i][j] * travellers[i][j];
                total_people += travellers[i][j];
            }
    
    average_time /= total_people;
    return average_time;
}


int main(int argc, char** args) {
    if(argc != 4) {
        cerr << "Invalid no. of arguments. Usage:\n" << args[0] << " [input file] [correct solution] [solution to test]\n";
        return 0;
    }
    ifstream in(args[1]), cor(args[2]), out(args[3]);
    
    in >> n >> m;
    pts.resize(n);
    for(int i=0;i<n;i++)
        in >> pts[i].x >> pts[i].y;
    
    for(int i=0;i<n;i++) {
        for(int j=0;j<n;j++) {
            in >> travellers[i][j];
        }
    }
    
    double score = get_average_time(cor) / get_average_time(out);
    ostringstream oss;
    oss << fixed << setprecision(2) << score;
    quit(score, "OK, Score is: " + oss.str());
    
    return 0;
}

